#include <stdio.h>
#include <math.h>
#define n 6000
#define n1 4096
#define n2 4032
#define r0  1.1              // 1.1*0.455 =0.5"
#define p60 60               // put cali_par at 60 row
char head[72][80],f1[30],b[30],c[80],d[150],e[150],ty;
FILE   *fp,*fp1,*fp2;
float  see,sky,gain,rdno,x1,x2,ava,sig,xx1;
float  z1,z2;
int    i0,i1,i2,ic;
double a8[8],b8[8],xx[n],yy[n],x,y,x3,x4,r,cx,cy,pi;
float  a73[n],dao[n],arr[n],drr[n],u73,g73,u_g;
char   mark[n],c0=34,cc;
int    ccdno,m,pg=0,idate;
float  ava4[4],sig4[4];
int    m4[4],k4[4];
main(int ac,char **av)
{
  int i,j,k,jj,kp=0;
  if(ac<2){ printf("\n\t******* use DR973 to calibrating *********** \n");
            printf("\n\tUsage: c44a73 p*.fit [!,%,g 1~4]\n");
            printf("\n\t 1~4, not draw 1/4 star\n");
            printf("\n\t mag: 15~~21.5 +add ZouHu judge\n");
            printf("\n\t ! /xw % /xw  g /jg \n\n");
            exit(0);
          }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  system("cp /vega2/rhbin/uefault.param default.param");
  system("cp /vega2/rhbin/uefault.conv default.conv");
  system("cp /vega2/rhbin/uefault.nnw default.nnw");
  cc=av[ac-1][0];
  if(cc=='!' || cc=='%' || cc=='g' || (cc<='4' && cc>='1') ){ ac--; pg=1; }
  for(i=1;i<ac;i++){
    strcpy(f1,av[i]);
    k=nindex(f1,"."); if(k<0)strcat(f1,".fit");
    sscanf(&f1[1],"%d",&k);
    idate=0;                // 2010
    if(k>5700)idate=1;  // 2011
//  if(k>6000)idate=2;
    printf("%3d: %s ******\n",i,f1);
    if(f1[0]!='p'){ printf("not a p*_? file\n"); continue; }
    fp=fopen(f1,"rb+");
    if(fp==0){ printf("not found!\n");  continue; }
    fread(head,72,80,fp);
    k=indexpos(head,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&head[k+j][10],"%lf",&a8[j]);
    xytoad(a8,b8);
    k=indexpos(head,"CCD_NO: ",72); sscanf(&head[k][15],"%d",&ccdno);
    k=indexpos(head,"SEEING  ",72); sscanf(&head[k][15],"%f",&see);
    k=indexpos(head,"SKYADU  ",72); sscanf(&head[k][15],"%f",&sky);
    k=indexpos(head,"GAINCAL ",72); 
    sscanf(&head[k][10],"%f %f %lf %lf",&x1,&x2,&x3,&x4); gain=(x1+x2+x3+x4)/4.;
    k=indexpos(head,"RDNOCAL ",72); 
    sscanf(&head[k][10],"%f %f %lf %lf",&x1,&x2,&x3,&x4); rdno=(x1+x2+x3+x4)/4.;

    strncpy(b,&head[6][53],25);
    for(j=0;j<9;j++)if(b[j]==32)break;
    if(j!=9){ printf("not coordinated!\n"); continue; }
    sprintf(c,"dr973 %s 31 c44.a73 22.0",b);
    system(c);                          
    m=0;
    fp1=fopen("c44.a73","r");
l10:
    fgets(d,150,fp1); if(feof(fp1))goto l20;
    if(d[0]=='#')goto l10;
    sscanf(&d[64],"%f%f %c%f",&u73,&arr[m],&ty,&g73);  mark[m]=0;
    if(u73==0. || g73==0.)goto l10;
    chs(&d[6],&x3);  chs(&d[19],&x4);
    rad_xy(a8[6],a8[7],x3,x4,&x,&y,2,0);
    if(x<10. || x>n1-10.)goto l10;
    if(y<10. || y>n2-10.)goto l10;
    if(ty=='g')goto l10;               // non_star
//    if(arr[m]>0.05)goto l10;           // keep < 0.5 objects
    if(arr[m]>0.1)goto l10;            // 20130131 change to 0.1mag
    u_g=u73-g73;                       // formula from zouhu 20130116 
    if(u_g<0.8 || u_g>2.4)goto l10;
//    a73[m]=u73+0.05804-0.07168*u_g+0.02213*u_g*u_g;   // adjust SDSS
    a73[m]=u73+0.11689-0.15371*u_g+0.05054*u_g*u_g;   // adjust SDSS 130127

//printf("%f %f %f\n",a73[m],u73,arr[m]);
   
    if(ccdno==4 && idate==0)if(x<n1/2-10. || y>n2/2-10.)goto l10;
    if(cc=='1')if(x < n1/2 && y > n2/2)goto l10; 
    if(cc=='2')if(x < n1/2 && y < n2/2)goto l10; 
    if(cc=='3')if(x > n1/2 && y > n2/2)goto l10; 
    if(cc=='4')if(x > n1/2 && y < n2/2)goto l10; 
    xx[m]=x; yy[m]=y;
    if(m<n)m++;
    goto l10;
l20:
    fclose(fp1); 
    if(m<2){ printf("less U standard star in this area\n"); continue; }
  
    fp2=fopen("/vega2/rhbin/uefault.sex","r");
    fp1=fopen("default.sex","w");
l30:
    fgets(c,80,fp2); if(feof(fp2))goto l40;
    if(c[0]=='G'&&c[1]=='A'&&c[2]=='I'){sprintf(&c[6],"%4.1f",gain);c[10]=9;}
    if(c[0]=='S'&&c[1]=='E'&&c[2]=='E'){sprintf(&c[12],"%5.2f",see);c[17]=9;}
    fputs(c,fp1); goto l30;
l40:
    fclose(fp1);
//    sprintf(c,"sex %s",f1);
//    system(c);                           // get test.cat
//    fp1=fopen("test.cat","r");
    getdao16(f1,gain, rdno);
    fp1=fopen("test.ap","r");
    for(j=0;j<3;j++)fgets(d,150,fp1);
l50:
    fgets(d,150,fp1); if(feof(fp1))goto l60;
    fgets(d,150,fp1); fgets(e,150,fp1);
    sscanf(d,"%d%lf%lf",&k,&x3,&x4);
    sscanf(&d[89],"%f",&x1);          // radius 16 pixel
    sscanf(&e[89],"%f",&x2);          // 20130131 8-->16
//    sscanf(&d[48],"%f %f %lf %lf",&x1,&x2,&x3,&x4);
    if(x1>25.)goto l50;
    r=r0;                      // err 1 pixel, 0.455"
    for(j=0;j<m;j++){
      x=xx[j]-x3; x*=x; 
      y=yy[j]-x4; y*=y; 
      x=sqrt(x+y);
      if(x<r){r=x; k=j; }
    } 
    if(r!=r0){                            // weigh= 1. / (rms*rms)
      dao[k]=a73[k]-x1; drr[k]=1./(x2*x2+arr[k]*arr[k]); 
                                          // 16.~20.5 --> 15~~21.5
      mark[k]=2; if(a73[k]>21.5 || a73[k]<15.)mark[k]=1;
    } goto l50;
l60:
    fclose(fp1);
    printf("a73: %4d    0.5%c_match: ",m,c0);
l70:
    x1=x2=0.;    xx1=0.;
    for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=dao[j]*drr[j]; xx1+=drr[j]; }
    printf(" %4d ",k);
    ava=x1/xx1;  
    for(j=0;j<m;j++)if(mark[j]==2) x2+=(dao[j]-ava)*(dao[j]-ava);
    sig=sqrt(x2/k); 
    printf(" av: %6.3f %6.3f\n",ava,sig);
    sig*=3.;
    for(j=ic=0;j<m;j++)if(mark[j]==2){
      x2=dao[j]-ava; if(x2<0.)x2=-x2;
      if(x2>sig){ mark[j]=-1; ic++; }
    }
    if(ic){ printf("\t  3_sigma_match: "); goto l70;  }
//    ic=indexpos(head,"OBJECT  ",72);
//    if(ic!=72)for(j=21;j<79;j++)head[ic][j]=32;       //clear c5 write
    for(ic=p60;ic<p60+5;ic++)for(j=0;j<80;j++)head[ic][j]=32;
    sig/=3.;  r=pow(10,(ava-4.)*0.4);
    sprintf(&head[p60][0],"CALIA73 =%21.3f / rms:%5.3f  a73:%4d  matched:%4d  W:%7.4lf",
     ava,sig,m,k,r);    for(j=77;j<80;j++)head[p60][j]=32;
    printf("Weight: %7.4lf\n",r);
    if(k<9){ for(j=0;j<80;j++)head[p60][j]=32;
              printf("******* less matched (<10), not write down to file\n"); }
    fseek(fp,0,0); fwrite(head,72,80,fp); fclose(fp);
    if( cc>='1' && cc<='4' )cc='!';
    if(k<9)continue;
    if(pg){
      i0=0; i1=1;
      if(cc=='!' || cc=='%')pgbegin_(&i0,"/xw",&i1,&i1,3);
      if(cc=='g')pgbegin_(&i0,"/jg",&i1,&i1,3);
      if(cc=='%'){
        x1=610., x2=600.;              pgpap_(&x1,&x2);
        x1=z1=0.; x2=4096.; z2=4032.;  pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
        pglabel_("a73-dao-cali_mag, red circle under AV","15.~~21.5m",f1,37,10,strlen(f1));
        for(j=0;j<m;j++)if(mark[j] && a73[j]>15. && a73[j]<21.5){
          z1=xx[j]; z2=yy[j]; pgpoint_(&i1,&z1,&z2,&i1);
          x1=(dao[j]-ava)*9.;
          ic=2; if(x1<0.){ x1=-x1; ic=1; }   pgsci_(&ic);
          i2=x1+0.5; i2+=21; 
          if(i2<27){ z1=xx[j]; z2=yy[j]; pgpoint_(&i1,&z1,&z2,&i2); }
        } pgend_();        continue;
      }
      x1=600., x2=600.;        pgpap_(&x1,&x2);
      x1=14.; x2=23.; z1=10.; z2=19.;
      pgsci_(&i1); pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
      pglabel_("DR973_median_mag","DAO AP(16) mag",f1,16,14,strlen(f1));
      sprintf(c,"calibration:%9.3f    rms:%9.3f  %d/%d",ava,sig,k,m);
      x1=14.5; z1=18.0; pgtext_(&x1,&z1,c,strlen(c));
      sprintf(c,"skyadu:  %9.2f",sky);
      x1=14.5; z1=17.5; pgtext_(&x1,&z1,c,strlen(c));
      sprintf(c,"seeing:%9.2f",see);
      x1=14.5; z1=17.0; pgtext_(&x1,&z1,c,strlen(c));
      for(j=0;j<m;j++)if(mark[j]){
        ic=mark[j]*2; if(ic<0)ic=-ic; ic--; pgsci_(&ic);
        x1=a73[j]; x2=a73[j]-dao[j];
        pgpoint_(&i1,&x1,&x2,&i1);
      }
      pgend_();
      if(cc=='g'){
        strcpy(b,f1); b[0]='a';
        j=strlen(b)-3; b[j++]='g'; b[j++]='i'; b[j]='f';
        if(kp==0)sprintf(c,"mv pgplot.gif %s",b);
        else     sprintf(c,"mv pgplot%d.gif %s",kp%10,b); 
        system(c); kp++;
        printf("%s\n",c);
      } 
    }    
    if(ccdno==4 && idate==0)continue;
//    for(j=0;j<m;j++)if(mark[j])printf("%d %lf %lf %f %f %d\n",
//      j+1,xx[j],yy[j],dao[j],arr[j],mark[j]);
    for(j=0;j<4;j++){
      get4cali(m,j+1,&ava4[j],&sig4[j],&m4[j],&k4[j]); 
      if(k4[j]==0){ ava4[j]=ava; sig4[j]=sig; }
      r=pow(10,(ava4[j]-4.)*0.4);
      printf("Gate %d:%4d/%d   av:%8.3f%7.3f  Weight: %7.4f\n",
              j+1,k4[j],m4[j],ava4[j],sig4[j],r);
      sprintf(&head[p60+j+1][0],"CALIA73%d=%21.3f / rms:%5.3f  a73:%4d  matched:%4d  W:%7.4lf",
      j+1,ava4[j],sig4[j],m4[j],k4[j],r);    head[p60+j+1][77]=32;
    }
    fp=fopen(f1,"rb+"); fseek(fp,0,0); fwrite(head,72,80,fp); fclose(fp);
  }
}

get4cali(m,gate,ava4,sig4,m4,k4)
int m,gate,*m4,*k4; float *ava4,*sig4;
{
  int j,k,ic,mm=0;
  float ava,sig, x1,x2,xx1;
  *k4=0;
  for(j=0;j<m;j++)if(mark[j]>0){
    mark[j]=2; if(a73[j]>21.5 || a73[j]<15.)mark[j]=1;
    if(gate==1)if(xx[j]>n1/2 || yy[j]<n2/2)mark[j]=1; 
    if(gate==2)if(xx[j]>n1/2 || yy[j]>n2/2)mark[j]=1; 
    if(gate==3)if(xx[j]<n1/2 || yy[j]<n2/2)mark[j]=1; 
    if(gate==4)if(xx[j]<n1/2 || yy[j]>n2/2)mark[j]=1; 
    if(mark[j]==2)mm++;
  } *m4=mm; if(mm<8)return; 
l70:
  x1=x2=xx1=0.;
  for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=dao[j]*drr[j]; xx1+=drr[j]; }
  ava=x1/xx1;  
  for(j=0;j<m;j++)if(mark[j]==2) x2+=(dao[j]-ava)*(dao[j]-ava);
  sig=sqrt(x2/k); 
  for(j=ic=0;j<m;j++)if(mark[j]==2){
    x2=dao[j]-ava; if(x2<0.)x2=-x2;
    if(x2>3.*sig){ mark[j]=1; ic++; }
  } if(ic)goto l70;  
  *ava4=ava; *sig4=sig;
  *k4=k;   
}

getdao16(f1,gain,rdno)
char *f1; float gain,rdno;
{
  char f2[20],a[160],t[60];
  FILE *fp2,*fp3;
  float x,y,u,v;
  int i,j=0;
  sprintf(t,"sex %s",f1);  system(t);
  fp2=fopen("test.cat","r");
  strcpy(f2,f1); for(i=0;i<strlen(f2);i++)if(f2[i]=='.')break; f2[i]=0;
  sprintf(t,"%s.coo",f2);  
  fp3=fopen(t,"w");
// 20130202, LOWBAD too high for weak EXP pic, changeto 9.9  ~sig
  fprintf(fp3," NL   NX   NY  LOWBAD HIGHBAD  THRESH");
  fprintf(fp3,"     AP1  PH/ADU  RNOISE    FRAD\n");
  fprintf(fp3,"  1 4096 4032     0.9 60000.0   22.76   10.00");
  fprintf(fp3,"%8.2f%8.2f    10.00\n\n",gain,rdno);
l10:
  fgets(a,160,fp2); if(feof(fp2))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(&a[67],"%f %f %f %f",&x,&y,&u,&v);
  if(v>99.)goto l10;              // along major axis, too big star 20120610
  if(x<10 || x>n1-10)goto l10;
  if(y<10 || y>n2-10)goto l10;
  fprintf(fp3,"%5d %9.3f %9.3f\n",++j,x,y);
  goto l10;
l20:
  fclose(fp2); fclose(fp3);
  sprintf(t,"u_phot4k %s",f2);   system(t);
  sprintf(t,"mv %s.ap test.ap",f2); system(t);
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[128];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
/*                         // same discribe formula as following 3 lines
  double sd,cd,td,co;      // china bai_ke_quan_shu (astronmy) p.552
  sd=sin(dc);  cd=cos(dc);  td=tan(der);
  co=cos(rar-ac);  tmp=sd*td+cd*co;
  xi=sin(rar-ac)/tmp;
  xn=(cd*td-sd*co)/tmp;
*/
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}
